#include <ctype.h>
#include <misc.h>
#include "etc.h"

#if 0
/*
	saute les caractres blancs du chaine
	Retourne un pointeur vers le premier caractre non blanc
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_skip(const char *str)
{
	while (isspace(*str)) str++;
	return ((char*)str);
}

/*
	saute une srie de chiffres
	Retourne un pointeur vers le premier caractre non chiffres
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_skipdig(const char *str)
{
	while (isdigit(*str)) str++;
	return ((char*) str);
}
/*
	saute un mot compos de caractres non blancs
	Retourne un pointeur vers le premier caractre blanc
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_skipword(const char *str)
{
	while (*str > ' ') str++;
	return ((char*) str);
}
#endif
/*
	Positionne au dbut du prochain mot.
	Si pointe sur un mot, saute par dessus et saute les blancs suivant.
	Si pointe sur un blanc, saute les blancs.
	Si pointe sur '\0', fait rien.
*/
export char *str_nextword(const char *str)
{
	if (str[0] != '\0'){
		if (isspace(str[0])){
			str = str_skip (str);
		}else{
			str = str_skip(str_skipword(str));
		}
	}
	return (char*)str;
}
/*
	saute un certain nombre de mot compos de caractres non blancs
	Retourne un pointeur vers le n'ime mot
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_skipnword(const char *str, int nbskip)
{
	int i;
	for (i=0; i<nbskip; i++){
		while (isspace(*str)) str++;
		while (*str > ' ') str++;
	}
	while (isspace(*str)) str++;
	return ((char*) str);
}

/*
	Compte le nombre de mot dans une chaine
*/
export int str_nbword (const char *str)
{
	int ret = 0;
	str = str_skip(str);
	while (*str != '\0'){
		str = str_skip(str_skipword(str));
		ret++;
	}
	return ret;
}	


#if 0
/*
	Copie un mot compos de caractres non blancs
	Retourne un pointeur vers le premier caractre blanc aprs le mot
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_copyword(char *dest, const char *str)
{
	while (isgraph(*str)) *dest++ = *str++;
	*dest = '\0';
	return ((char*) str);
}
#endif

/*
	Copie une srie de chiffre d'une chaine
	Retourne un pointeur vers le premier caractre aprs la srie
	ou un pointeur vers la fin de la chaine '\0'
*/

export char *str_copydig(char *dest, const char *str)
{
	while (isdigit(*str)) *dest++ = *str++;
	*dest = '\0';
	return ((char*) str);
}

