#include <string.h>
#include <errno.h>
#include <misc.h>
#include "projet.h"
#include "projetx.m"


static PROJET_LOG *foper_log = NULL;
								// Collecte ou affiche ou les deux
								// les oprations de copie.
/*
	Enregistre objet pour gnrer message  l'cran.
*/
void foper_setlog(
	PROJET_LOG *log)	// Enregistre les commandes dans un log
						// Peut tre NULL.
{
	foper_log = log;
}
/*
	Excute une copie de fichier avec gestion du log.
	Retourne -1 si erreur.
*/
static int near foper_copyp (
	const char *src,
	const char *dst)		// Path destination (rpertoire)
{
	char cwd[MAXSIZ_PATH];
	path_getcwd(cwd,sizeof(cwd));
	if (foper_log != NULL){
		foper_log->printf ("%s # copy %s %s\n",cwd,src,dst);
	}
	int ret = -1;
	// S'assure que le rpertoire destination existe, sinon cration.
	if (file_type(dst) == 1
		|| file_mkdiranc(dst) != -1){
		char path[MAXSIZ_PATH];
		path_make (dst,src,path);
		ret = file_copyp (src,path);
		if (ret == -1){
			if (foper_log != NULL){
				foper_log->printf ("    **** Erreur copy errno=%s\n"
					,strerror(errno));
			}
			xconf_error (MSG_U(E_COPY
				,"Copie incomplte\n%s/%s -> %s\n")
				,cwd,src,path);
		}
	}else{
		if (foper_log != NULL){
			foper_log->printf ("    **** Erreur cration %s errno=%d\n"
				,dst,strerror(errno));
		}
		xconf_error (MSG_U(E_DIRCREATE
			,"Ne peut pas crer le rpertoire\n%s")
			,dst);
	}
	return ret;
}


/*
	Enregistre une rvision d'un fichier dans l'archive (/kit/ombre).
	Le fichier est dans le rpertoire courant.

	Retourne -1 si erreur.
*/
int foper_archive (
	const char *nom,
	const char *projet,
	const REVISION *rev,
	const USERINFO *user)
{
	char path[MAXSIZ_PATH];
	user->makombpath(projet,path);
	char revstr[MAXSIZ_PATH];
	rev->formatpath (revstr);
	strcat (revstr,".s");
	path_make (path,revstr,path);
	return foper_copyp (nom,path);
}
/*
	Enregistre une rvision d'un fichier dans le backup de livraison
	(/kit/livre).
	Le fichier est dans le rpertoire courant.

	Retourne -1 si erreur.
*/
int foper_backup (
	const char *nom,
	const char *projet,
	REVISION *rev,
	USERINFO *user)
{
	char path[MAXSIZ_PATH];
	char revstr[MAXSIZ_REVISION+1];
	rev->formatpath (revstr);
	user->maklivpath(revstr,path);
	path_make (path,projet,path);
	return foper_copyp (nom,path);
}

