#include <misc.h>
#include <dialog.h>
#include "projet.h"
#include "projetx.m"

/*
	Retourne le nom du programmeur associ  un rvision.
*/
const char *intgdat_rev2prog(const char *revision)
{
	REVISION rev(revision);
	return prog_num2str(rev.getprog());
}

/*
	Dialogue pour intgration de plusieurs versions d'un rpertoire.
	Retourne != 0 si intgration a t faite, 0 si abandon.
*/
PUBLIC int INTEGRE_FILE::menudir (
	long mskwin,
	EVENT *cmd,
	BOUTON_FCT *but)
{
	PAGE_EDIT page ("menudir");
	char nomdir[MAXSIZ_NAME];
	path_splitlex (fname,nomdir,NULL);
	page_setuptitre (&page,MSGTIT_INTGDIR,nomdir);
	for (int i=0; i<getnb(); i++){
		INTG_TRANS *tra = item(i);
		page_setupfixestr0 (&page,-1,intgdat_rev2prog(tra->revs.root),-1);
		page_setupfixestr0 (&page,-1,tra->revs.dir,-1);
	}
	bouton_setupstd  (&page,"cancel");
	bouton_setupuser (&page,MSGBUT_EFFACE,K_NULL,PAGE_VAL_USER1);
	bouton_setupuser (&page,MSGBUT_GARDE ,K_NULL,PAGE_VAL_USER2);
	page.linedesign0(2);
	page.setspec (but);
	PAGE_VAL val = page.edit (mskwin,cmd);
	int ret = 0;
	if (val == PAGE_VAL_USER1){
		// On dtruit le sous-rpertoire sans question.
		dir_delete (nomdir,NULL);
		ret = 1;
	}else if (val == PAGE_VAL_USER2){
		// Le rpertoire est accept, on ne fait rien. L'usager devra
		// accept chaque fichier du rpertoire.
		// Il y a un integre.dat qui a t cr spcifiquement pour ce
		// sous-rpertoire.
		ret = 1;
	}
	return ret;
}

