#include <stdio.h>
#include <stdlib.h>
#include "projet.h"
#include "projetx.m"

/*
	Inscrit dans le log et affiche sur stdout aussi
*/
class DUAL_LOG: public PROJET_LOG{
public:
	DUAL_LOG(const char *path, int append);
	void sendstr (const char *str);
};

DUAL_LOG::DUAL_LOG(const char *_path, int _append)
	: PROJET_LOG(_path,_append)
{
}
void DUAL_LOG::sendstr (const char *str)
{
	PROJET_LOG::sendstr(str);
	::printf ("%s",str);
}

/* #Spcification: admin / export
	Une copie de l'archive est disponible a plusieurs sites.
	Ce prend un mcanisme qui va permettre de maintenir
	la synchronisation. Les diffrents sites sont relis
	par courier lectronique (modem). L'archive a une dimension
	considrable (80megs). On peut pas tout copier constamment.
*/
/* #Spcification: admin / export / /kit/livre
	A chaque livraison, un copie est dpos dans /kit/livre.
	Le role de /kit/livre est double. Il agit d'une part
	comme mcanisme de scurit lors de la livraison. Si un
	problme survient et que l'archivage est interrompue, le
	contenu de /kit/livre et du rpertoire usager devrait permettre
	de recuprer les fichiers. /kit/livre est passablement
	redondant par rapport a /kit/ombre (l'archive). Cela est
	souhait et agit comme un garantie supplmentaire.

	/kit/livre a aussi t ralis comme rpertoire temporaire
	pour la distribution des nouvelles rvisions aux autres sites.
*/

int main (int argc, char *argv[])
{
	int ret = -1;
	if (argc == 1){
		/* #Spcification: admin / export / ligne de commande
			L'option d'exportation est disponible en mode ligne de
			commande. Le programme s'appelle prjexpr. On peut l'utiliser
			de la faon suivante.

			prjexpr site [ site ... ]
		*/
		fprintf (stderr,"prjexpr site [ site ... ]\n");
		fprintf (stderr,"Met  jour les diffrents sites satellites\n");
		fprintf (stderr," partir de /kit/ombre/version.dat\n");
	}else{
		char *prog = getenv("VCSID");
		if (prog == NULL) prog = getenv ("USER");
		if (prog == NULL){
			xconf_error (MSG_U(E_VCSID
				,"Incapable de vous identifier\n"
				 "Variable VCSID ou USER doit etre definie"));
			exit (-1);
		}
		USERINFO *user = userinfo_findenv (prog);
		if (user != NULL){
			/* #Spcification: admin / export / export.log
				Le fichier /kit/sync/export.log indique toutes les rvisions
				qui ont t transmises au diffrents sites de /kit/sync.
			*/
			char pathlog[MAXSIZ_PATH];
			user->maksyncpath("export.log",pathlog);
			DUAL_LOG log (pathlog,1);
			VERSION_DAT princ (user);
			ret = 0;
			for (int i=1; i<argc; i++){
				char *site = argv[i];
				if (export_site (user,princ,site,log)==-1){
					ret = -1;
					break;
				}
			}
		}
	}
	return ret;
}

