TOOLS_VERSION=1
TOOLS_RELEASE=1
LDEVEL=/usr/lib/linuxconf-devel/
SOLUCORP_LIB=/usr/lib/linuxconf-tools
PROJETX_ETC=/etc/register
FLAGS=-funsigned-char -g -O2 -Wall 
EGCS=$(shell test -f /usr/bin/egcs && /bin/echo -n 1)
ifeq ($(EGCS),1)
GPPLINK=egcs
GPP=egcs
else
GPP=g++
# Using g++ to link pulls libg++ even if the program does not need it
GPPLINK=gcc
endif

CPP_DEFINES=-Dexport= -DSTATIC= -DEXPORT= -DPUBLIC= -DPROTECTED= -DPRIVATE= -DVIRTUAL= \
	-Dnear= -Dfar=  -D_GNU_SOURCE -DUNIX -DTOOLS_VERSION=$(TOOLS_VERSION) \
	-DTOOLS_RELEASE=$(TOOLS_RELEASE)

.cc.o:
	@echo "    " $<
	@$(GPP) $(FLAGS) $(CPP_DEFINES) -I../tool -I../etc -I../lexc \
		-I/usr/include/linuxconf -c $< -o $@


lib: $(CURDIR).a

$(CURDIR).a: $(OBJS)
	ar cr $(CURDIR).a $(OBJS)
	ranlib $(CURDIR).a


msg:
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc

msg.clean:
	$(LDEVEL)/msgclean $(CURDIR).dic
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc

msg.eng:
	mkdir -p $(RPM_BUILD_ROOT)$(SOLUCORP_LIB)/help.eng
	$(LDEVEL)/msgcomp -p./ -p$(LDEVEL)/messages/sources/ \
		-p../etc/ -p../tool/unix/ -p../tool/common/ -p../nadoc/ -p../projetx/ \
		-p../lexc/ -p../proto/ \
		$(RPM_BUILD_ROOT)$(SOLUCORP_LIB)/help.eng/linuxconf-tools.eng eE \
		projetx etc unix common nadoc dialog misc diajava proto lexc

ifdef DIRS
clean: $(LOCAL_CLEAN)
	rm -f x *.o *.obt *.bak .bak *~ *.a *.old *.log *.nap *.nar core
	@for i in $(DIRS); do make -C $$i clean  || exit 1; done
else
clean: $(LOCAL_CLEAN)
	rm -f x *.o *.obt *.bak *~ *.a *.old *.log *.nap *.nar
endif

all:
ifdef DIRS
	@for i in $(DIRS); do make GCC=$(GCC) GPP=$(GPP) -C $$i $@ || exit 1; done
endif


ifdef DIRS
install: $(LOCAL_INSTALL) install_subdirs $(LOCAL_POSTINSTALL)

install_subdirs:
	@echo doing subdirs
	@for i in $(DIRS); do make -C $$i install  || exit 1 ; done
	@echo end subdirs

else
install: $(LOCAL_INSTALL) $(LOCAL_POSTINSTALL)
endif

