#include <sys/vfs.h>
#include "tool.h"

/*
	Retourne l'espace libre dans une partition
	Retourne -1 si erreur.
*/
export long file_getfree (const char *path)
{
	struct statfs buf;
	long ret = statfs (path,&buf);
	if (ret != -1){
		// printf ("buf avail %ld\n",buf.f_bavail);
		// printf ("buf size %ld\n",buf.f_bsize);
		ret = buf.f_bavail * buf.f_bsize;
	}
	return ret;
}

/*
	Retourne la longueur maximum permise pour un nom de fichier
	(Spcifique au type de file system).
	Retourne -1 si erreur.
*/
export int file_getname_len (const char *path)
{
	struct statfs buf;
	int ret = statfs (path,&buf);
	if (ret != -1){
		ret = buf.f_namelen;
	}
	return ret;
}

